		cpu	z80

; FILE: 	U880 VEB POLYTECHNIK
; PSF 93--9.JUNE1983
; GROESSE: 1024 BYTES
; RAM: 1C00H TO 1FFFH 1K
; ROM: 0000H TO 03FFH 1K
; PIO1: PORT 1A,1B (CONTROL) 18,19 (DATA)
; PIO2: PORT 2A,2B (CONTROL) 28,29 (DATA)
; CTC: 30,31,32,33
; SOFTSERIAL: 110 to 19200 BAUD
; INTEL HEX LOAD UP TO 2400 BAUD
; HIGHER RATES NEED 1MS DELAY PER CHAR

RAMTOP 		equ	 1FFFH
RAMBOT 		equ	 1C00H
CTC_C0 		equ	 030H
CTC_c1 		equ	 031H
CTC_C2 		equ	 032H
CTC_C3 		equ	 033H
PIO_PA1 	equ	 018H
PIO_PB1 	equ	 019H
PIO_PA2 	equ	 028H
PIO_PB2 	equ	 029H
PIO_CA1 	equ	 01AH
PIO_CB1 	equ	 01BH
PIO_CA2 	equ	 02AH
PIO_CB2 	equ	 02BH
MIRQ1 		equ	 01C00H
MIRQ2 		equ	 01C02H
MTIM0 		equ	 01C04H
MTIM1 		equ	 01C06H
MTIM2 		equ	 01C08H
MTIM3 		equ	 01C0AH
MNMI 		equ	 01C0CH
MRST08 		equ	 01C0EH
BITTIM 		equ	 01C10H 	; SERIAL BIT TIME
HALFTIM 	equ	 01C12H
ECHO 		equ	 01C14H 	; ECHO IF VALUE = 0
CHAR_IN 	equ	 01C15H

		ORG 00000H
;
L0000:		ld	hl, RAMBOT
		ld	de, RAMBOT+1
		jr	RESET

;
L0008:					; RST08
		ld	hl, MRST08
		jp	(hl)
;
		ORG 00010H
L0010:
		dw MIRQ1		; ADRESS VECTORS FOR PIO 2A AND 2B
		dw MIRQ2

		ORG 00014H
L0014:
		dw MTIM0		; BASE ADRESS IJECTORS FOR CTC TIMERS
		dw MTIM1
		dw MTIM2
		dw MTIM3
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
RESET:					; RESET
		ld	sp, RAMTOP-3	; STACK	1FFC
		xor	a		; IRQ UECTOR REGISTER=00
		ld	i, a
		im	2		; IRQ MODE 2
		ld	a, 7Fh
		out	(PIO_CA1), a	; SET PIO 1 A,B	SET TO INPUT MODE 1
		out	(PIO_CB1), a
		out	(PIO_CA2), a	; SET PIO 2 A,B	SET TO INPUT MODE 1
		out	(PIO_CB2), a
		ld	bc, 3FFh	; 1K COPY
		ld	(hl), 0		; CLEAR	RAM
		ldir			; INITIAL UALUES TO RAM
		jp	WARM


		ORG	00038H
L0038:
		reti			; RST38	INT AND	INTERRUPT MODE 1

DUMMY:
		reti

;
WARM:		call	SET_CTC		; PORT MODES
					; PIO 1 PORTA =	MODE 1,NO IRQ
					; PIO 1 PORT B = MODE 3,NO IRQ,OUTPUT C0(B7,B6 ARE INPUTS)SET TO 70
					; PIO 2 PORT A = MODE 0,OUTPUT 00,IRQ 0024 ON ASTROBE
					; PIO 2 PORT B = MODE 0,OUTPUT 00,IRQ 0026 ON BSTROBE
					;
					; CTC CONNECTIONS
					; PIO 2 ASTROBE <> CTC TIMER 1 (T01 INVERTED)
					; PIO 2 BSTROBE <> CTC TIMER 2 (T02 INVERTED)
					;
		ld	a, 7		; CLEAR IRQ
		out	(PIO_CA1), a	; SET PIO 1 A IRQ CONTROL (DISABLE IRQ) NO MASK
		out	(PIO_CB1), a	; SET PIO 1 B IRQ CONTROL (DISABLE IRQ) NO MASK

		xor	a		; PREDEFINDED DATA PORTS
		out	(PIO_PA1), a	; DATA PIO1A=00
		out	(PIO_PA2), a	; DATA PIO2A=00
		out	(PIO_PB2), a	; DATA PIO2B=00
		ld	a, 70h		; DATA PIO1B=70
		out	(PIO_PB1), a

		ld	a, 3Fh		; SWITCH PORTS TO OUTPUT
		out	(PIO_CB2), a	; SET PIO 2 B TO OUTPUT (00 INITIAL)
		out	(PIO_CA2), a	; SET PIO 2 A TO OUTPUT (00 INITIAL)

		ld	a, 0FFh
		out	(PIO_CB1), a	; SET PIO 1 B TO MODE 3 BIT CONTROL

		ld	a, 0C0h		; MODE 3 I/0 WORD
		out	(PIO_CB1), a	; SET PIO 1 B I/O CONTROL TO C0 (B7 AND 86 = INPUT, OTHER OUTPUT)
		jp	WARM2

		ORG 00066H
		ld	hl, MNMI
		jp	(hl)
;
WARM2:		ld	a, 10h		; SET IRQ VECTORS
		out	(PIO_CA2), a	; SET PIO 2 A CONTROL TO 24 (VECTOR 0024)
		add	a, 2
		out	(PIO_CB2), a	; SET PIO 2 B CONTROL TO 26 (VECTOR 0026)

		ld	a, 87h		; INTERRUPT CONTROL WORD
		out	(PIO_CA2), a	; SET PIO 2 A CONTROL TO 87 ENABLE IRQ
		out	(PIO_CB2), a	; SET PIO 2 B CONTROL TO 87 ENABLE IRQ

		ld	hl, DUMMY	; SET IRW VECTOR IN RAM TO DUMMY
		ld	(MIRQ1), hl
		ld	(MIRQ2), hl

		ld	(MTIM0), hl
		ld	(MTIM1), hl
		ld	(MTIM2), hl
		ld	(MTIM3), hl

		ld	(MNMI),	hl

		call	BRID		; GET BAUDRATE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;INITIALIZATION	AND SIGN-ON MESSAGE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		ld	hl, LOGMSG	; "\r\n\nU880 UNIPOLY 1983\r\n<KARL-MARX-STADT>"...
		call	STROUT

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;MAIN COMMAND LOOP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CMDLP:		ld	hl, PROMPT	; "\r\n\n>"
		call	STROUT
		ld	hl, CMDLP	; GET CMDLP AODRESS IN HL
		push	hl		; PUSH HL, PRIME STACK FOR RET TO CMDLP
		call	CIN
		cp	'D'
		jp	z, MEMDMP
		cp	'E'
		jp	z, EDMEM
		cp	'G'
		jp	z, GO
		cp	'O'
		jp	z, OUTPUT
		cp	'I'
		jp	z, INPUT
		cp	'L'
		jp	z, LOAD
		cp	'H'
		jp	z, HELP
		ld	hl, ERR		; "BEFEHL ?"
		jp	ERROUT

;GET A PORT ADDRESS, WRITE BYTE	OUT
OUTPUT:		call	SPCOUT
		call	GETHEX
		ld	b, a
		call	SPCOUT
		call	GETHEX
		jp	JMPOUT

;INPUT FROM PORT, PRINT	CONTENTS
INPUT:		call	SPCOUT
		call	GETHEX
		ld	b, a
		call	SPCOUT
		ld	a, b
		call	JMPIN
		jp	HEXOUT

;SHOW HELP TEXT
HELP:		ld	hl, PHELP	; "\r\nD DISPLAY MEMORY	<AAAA BBBB>\r\nE EDIT "...
		jp	STROUT

;EDIT MEMORY FROM A STARTING ADDRESS UNTIL X IS
;PRESSED. DISPLAY MEM LOC, CONTENTS, AND RESULTS
;OF WRITE.
EDMEM:		call	SPCOUT
		call	ADRIN
		ld	h, d
		ld	l, e
ED1:		call	CRLF
		call	ADROUT
		call	SPCOUT
		ld	a, ':'
		call	COUT
		call	SPCOUT
		call	DMPLOC
		call	SPCOUT
		call	GETHEX
		ret	c
		ld	(hl), a
		call	SPCOUT
		call	DMPLOC
		inc	hl
		jr	ED1

;GET AN ADDRESS AND JUMP TO IT
GO:		call	SPCOUT
		call	ADRIN
		ld	h, d
		ld	l, e
		jp	(hl)

;DUMP MEMORY BETWEEN TWO ADDRESS LOCATIONS
MEMDMP:		call	SPCOUT
		call	ADRIN
		ld	h, d		; START IN HL
		ld	l, e
		ld	c, 10h
		call	SPCOUT
		call	ADRIN		; END IN DE
MD1:		call	CRLF
		call	DMP16
		ld	a, d		; HIGH BYTE OF END ADDRESS
		cp	h		; COMPARE CURRENT HIGH ADDRESS
		ret	m		; DONE IF CURRENT HIGH > END HIGH
		ld	a, e		; LOW BYTE OF END ADDRESS
		cp	l		; COMPARE CURRENT LOW ADDRESS
		jr	c, MD2		; CURRENT LOW > END LOW, CHECK FOR ROLLOVER
		jr	MD1		; CONTINUE DUMPING MEMORY
MD2:		ld	a, d		; HIGH BYTE OF END ADDRESS
		cp	h		; ARE HIGH BYTES THE SAME?
		jr	nz, MD1		; KEEP GOING IF UPPER BYTES AREN'T THE SAME
		ret			; DONE IF THEY ARE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;DMP16 -- DUMP 16 CONSECUTIVE MEMORY LOCATIONS
;
;PRE: HL PAIR CONTAINS STARTING MEMORY ADDRESS
;POST: MEMORY FROM HL TO HL * 16 PRINTED
;POST: HL INCREMENTED TO HL * 16
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DMP16:		call	ADROUT
		call	SPCOUT
		ld	a, ':'
		call	COUT
		ld	c, 10h
DM1:		call	SPCOUT
		call	DMPLOC
		inc	hl
		dec	c
		ret	z
		jr	DM1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;DMPLOC -- PRINT A BYTE AT HL TO CONSOLE
;
;PRE: HL PAIR CONTAINS ADDRESS OF BYTE
;POST: BYTE AT HL PRINTED TO CONSOLE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DMPLOC:		ld	a, (hl)
		jp	HEXOUT

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HEXOUT	-- OUTPUT BYTE TO CONSOLE AS HEX
;
;PRE: A	REGISTER CONTAINS BYTE TO BE OUTPUT
;POST: BYTE IS OUTPUT TO CONSOLE AS HEX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HEXOUT:		push	bc
		ld	b, a
		rrca
		rrca
		rrca
		rrca
		and	0Fh
		call	HEXASC
		call	COUT
		ld	a, b
		and	0Fh
		call	HEXASC
		call	COUT
		pop	bc
		ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HEXASC	-- CONVERT NIBBLE TO ASCII CHAR
;
;PRE: A	REGISTER CONTAINS NYBBLE
;POST: A REGISTER CONTAINS ASCII CHAR
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HEXASC:		add	a, 90h
		daa
		adc	a, 40h
		daa
		ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ADROUT	-- PRINT AN ADDRESS TO THE CONSOLE
;
;PRE: HL PAIR CONTAINS ADDRESS TO PRINT
;POST: HL PRINTED TO CONSOLE AS	HEX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ADROUT:		ld	a, h
		call	HEXOUT
		ld	a, l
		call	HEXOUT
		ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ADRIN -- GET AN ADDRESS WORD FROM CONSOLE
;
;PRE: NONE
;POST: DE CONTAINS ADDRESS FROM	CONSOLE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ADRIN:		call	GETHEX
		ld	d, a
		call	GETHEX
		ld	e, a
		ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;GETHEX	-- GET BYTE FROM CONSOLE AS HEX
;
;PRE: NONE
;POST: A REGISTER CONTAINS BYTE	FROM HEX INPUT
;POST: CARRY FLAG SET IF X WAS RECEIVED
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GETHEX:		push	de
		call	CIN
		cp	'X'
		jr	z, GE2
		call	ASCHEX
		rlca
		rlca
		rlca
		rlca
		ld	d, a
		call	CIN
		call	ASCHEX
		or	d
GE1:		pop	de
		ret
GE2:		scf
		jr	GE1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ASCHEX -- CONVERT ASCII CODED HEX TO NIBBLE
;
;PRE: A REGISTER CONTAINS ASCII CODED NIBBLE
;POST: A REGISTER CONTAINS NYBBLE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ASCHEX:		sub	CTC_C0
		cp	0Ah
		ret	m
		and	5Fh
		sub	7
		ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;JMPOUT -- OUTPUT TO A DYNAMIC PORT
;
;PRE: B REGISTER CONTAINS THE PORT TO OUTPUT TO
;PRE: A REGISTER CONTAINS THE BYTE TO OUTPUT
;POST: BYTE IS OUTPUT
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
JMPOUT:		ld	c, b
		out	(c), a
		ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;JMPIN -- INPUT FROM A DYNAMIC PORT
;
;PRE: A REGISTER CONTAINS THE PORT TO INPUT FROM
;POST: A REGISTER CONTAINS PORT VALUE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
JMPIN:		ld	c, a
		in	a, (c)
		ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SPCOUT -- PRINT A SPACE TO THE CONSOLE
;
;PRE: NONE
;POST: 0X20 PINTED TO CONSOLE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SPCOUT:		ld	a, ' '
		jp	COUT

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;STROUT	-- PRINT A NULL-TERMINATED STRING
;
;PRE: HL CONTAINS POINTER TO START OF A	NULL-
;	TERMINATED STRING
;POST: STRING AT HL PRINTED TO CONSOLE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
STROUT:		ld	a, (hl)
		and	a
		ret	z
		call	COUT
		inc	hl
		jr	STROUT

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ERROUT -- PRINT A NULL-TERMINATED ERROR STRING
;
;PRE: HL CONTAINS POINTER TO START OF A NULL-
;	TERMINATED STRING
;POST: STRING AT HL PRINTED TO CONSOLE
;POST: PROGRAM EXECUTION RETURNED TO COMMAND LOOP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ERROUT:		call	CRLF
		jp	STROUT

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;CRLF -- PRINT A CR, LF
;
;PRESERVES HL
;
;PRE: NONE
;POST: CR, LF PRINTED TO CONSOLE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CRLF:		push	hl
		ld	hl, PCRLF
		call	STROUT
		pop	hl
		ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;LOAD -- LOAD AN INTEL HEX FILE FROM CONSOLE
;
;!!!!!!!! WORKS OK UP TO 2400 BAUD
;!!!!!!!! HIGHER RATES NEED 1MS DELAY PER CHAR
;
;POST: INTEL HEX FILE LOADED, OR ERROR PRINTED
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LOAD:		call	CRLF		; NEWLINE
		ld	a, 1
		ld	(ECHO),	a	; NO ECHO DURING LOAD
LOAD1:		call	CINNE
		cp	':'
		jr	nz, LOAD1	; WAIT FOR START COLON
		call	GETHEX		; GET RECORD LENGTH
		ld	b, a		; RECORD LENGTH	IN B
		ld	c, a		; START	CHECKSUMMING IN	C
		call	GETHEX		; START	ADDRESS	HIGH BYTE
		ld	h, a		; STORE IN H
		add	a, c
		ld	c, a		; CHECKSUM
		call	GETHEX		; START	ADDRESS	LOW BYTE
		ld	l, a		; STORE IN L
		add	a, c
		ld	c, a		; CHECKSUM
		call	GETHEX		; GET RECORD TYPE
		ld	d, a		; STORE RECORD TYPE IN D
		add	a, c
		ld	c, a		; CHECKSUM RECORD TYPE
		ld	a, b		; CHECK RECORD LENGTH
		and	a
		jr	z, LOAD4	; LENGTH == 0, DONE GETTING DATA
LOAD2:		call	GETHEX		; THIS IS THE MAIN RECORD PROCESSING LOOP
		ld	(hl), a		; STORE	CHAR AT HL
		add	a, c
		ld	c, a		; CHECKSUM
		inc	hl		; MOVE MEMORY POINTER UP
		dec	b
		jr	nz, LOAD2	; NOT DONE WITH THE LINE
		call	GETHEX		; GET CHECKSUM BYTE
		add	a, c
		jr	nz, CSUMER	; CHECKSUM BAD,	PR:INT ERROR
		or	d
		jr	z, LOAD1	; RECORD TYPE 00, KEEP GOING

LOAD4:		call	CINNE		; DONE GETTING DATA, SILENTLY READ CHARS
		cp	0Ah		; CHECK FOR LF
		jr	nz, LOAD4
		ld	hl, OK		; PRINT OK TO CONSOLE
		jr	LOADOK
CSUMER:		ld	hl, CSERR	; PRINT CHECKSUM ERROR TO CONSOLE
LOADOK:		ld	a, 0
		ld	(ECHO),	a	; ECHO ON
		jp	ERROUT		; RET FROM ERROUT WILL RETURN TO COMMAND LOOP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;MONITOR STRINGS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

LOGMSG:		db 0Dh,0Ah,0Ah
		db "U880 UNIPOLY 1983",0Dh,0Ah
		db "<KARL-MARX-STADT> H=HILFE",0
PROMPT:		db 0Dh,0Ah,0Ah,'>',0
CSERR:db "FEHLER CHECKSUM"
ERR:		db "BEFEHL ?",0
OK:		db "OK",0
PCRLF:		db  0Dh,0Ah,0
PHELP:		db 0Dh,0Ah
		db "D DISPLAY MEMORY <AAAA BBBB>",0Dh,0Ah
		db "E EDIT MEMORY <AAAA> /X QUIT",0Dh,0Ah
		db "G GO TO ADDRESS <AAAA> /RET TO CMD",0Dh,0Ah
		db "I INPUT PORT <PP>",0Dh,0Ah
		db "O OUTPUT PORT <PP DD>",0Dh,0Ah
		db "L LOAD INTEL HEX",0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;CINNE -- GET A	CHAR FROM THE CONSOLE, NO ECHO
;
;PRE: CONSOLE DEVICE IS	INITIALIZED
;POST: RECEIUED	CHAR IS	IN A REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CINNE:		jp	BCIN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;CIN --	GET A CHAR FROM	THE CONSOLE AND	ECHO
;
;PRE: CONSOLE DEVICE IS	INITIALIZED
;POST: RECEIVEO	CHAR IS	IN A REGISTER
;POST: RECEIVEO	CHAR IS	ECHOED
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CIN:		call	CINNE
		cp	60h
		jr	c, CIN1
		and	0DFh		; UPPER CHAR ONLY

CIN1:		push	af
		ld	a, (ECHO)
		and	a
		jr	z, CINE
		pop	af
		ret
CINE:		pop	af

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;COUT -- OUTPUT	A CHARACTER TO THE CONSOLE
;
;PRE: A	REGISTER CONTAINS CHAR TO BE PRINTED
;POST: CHARACTER IS PRINTED TO THE CONSOLE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
COUT:		jp	BCOUT


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SET_CTC:	ld	a, 14h		; D7..D3 PROVIDE THE FIRST PART OF THE INT VECTOR (IN OUR CASE, $10), FOLLOWED BY
					; D2..D1, PROVIDED BY THE CTC (THEY POINT TO THE CHANNEL), D0=INTERRUPT WORD
		out	(CTC_C0), a
		ld	a, 87h		; INTERRUPT ON, TIMER MODE, PRESCALER=16, OON'T CARE EXT.TRG EDGE,
					; START TIMER ON LOADING CONSTANT, TIME CONSTANT FOLLOWS, SOFTWARE RESET, COMMAND WORD
		ld	a, 7		; INTERRUPT OFF, TIMER MODE, PRESCALER=16, DON'T CARE EXT.TRG EDGE,
					; START TIMER ON LOADING CONSTANT, TIME CONSTANT FOLLOWS, SOFTWARE RESET, COMMAND WORD
		out	(CTC_C1), a	; CH0 DOESN'T RUN
		ld	a, 168 		; TIME CONSTANT - 0 STANDS FOR 256
		out	(CTC_C1), a
		ret



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; BRID - DETERMINE THE BAUD RATE OF THE	TERMINAL. THIS ROUTINE
; ACTUALLY FINDS THE PROPER DIVISORS BITTIM ANO HALFST TO RUN CIN
; AND COUT PROPERLY.
;
; THE ROUTINE EXPECTS A	SPACE. IT LOOKS	AT THE 1 ONES IN THE
; 20H STREAM FROM THE SERIAL PORT AND COUNTS TIME FROM THE START
; BIT TO THE FIRST 1 (INVERSE INPUT)
;
;
BRID:		in	a, (PIO_PB1)	; READ SERIAL UNE
		and	0DFh
		out	(PIO_PB1), a	; SET SERIAL LINE HIGH
		ld	hl, -10		; BIT COUNT (CORRECTION)

BRI0:		in	a, (PIO_PB1)
		rla
		jr	c, BRI0		; LOOP TILL SERIAL NOT BUSY

BRI1:		in	a, (PIO_PB1)
		rla
		jr	nc, BRI1	; LOOP TILL START BIT COMES (FAST VERSION 8,9 INSTEAD OF 12.2 USEC)

BRI3:		ld	e, 3
BRI4:		dec	e		; 42 MACHINE CYCLE LOOP
		jp	nz, BRI4
		inc	hl		; INC COUNTER EVERY 98 CYCLES
					; WHILE SERIAL LINE IS LOW
		in	a, (PIO_PB1)
		and	80h
		jp	nz, BRI3	; LOOP WHILE SERIAL LINE LOW

;CYCLE CORRECTION OUTPUT

		push	hl		; SAVE COUNT FOR HALFST COMPUTATION
		inc	h		; ADD 1 FOR THE DEC LOOP IN CIN AND COUT
		inc	l
		ld	(BITTIM), hl	; SAVE BIT TIME
		pop	hl		; RESTORE COUNT
		xor	a		; CLEAR CARRY FOR DIVISION
		ld	a, h		; COMPUTE HL/2
		rra
		ld	h, a
		ld	a, l
		rra
		add	a, 6		; TIMING CORRECTION FOR HIGH BAUDRATES
		jr	nc, BRI5
		inc	h
BRI5:		ld	l, a		; HL=COUNT/2  CORRECTION
		inc	h
		ld	(HALFTIM), hl
		ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; OUTPUT THE CHARACTER IN A
;
; BITTIME HAS THE DELAY	TIME PER BIT, AND IS COMPUTED AS:
;
; <HL>'  =  ((FREQ IN HZ/BAUDRATE) - 98)/14
; BITTIM  =  <HL>'+101H (WITH NO INTERNAL CARRY PROP BETWEEN BYTES)
;
; AND OUT TO SERIAL_HIGH SETS THE SERIAL LINE HIGH; AN OUT
; TO SERIAL_LOW SETS IT LOW, REGARDLESS OF THE CONTENTS	SET TO THE
; PORT.
;
BCOUT:		di
		push	af
		push	hl
		push	bc
		ld	c, a
		ld	b, 11		; BITS TO SEND
					; (START, 8 DATA, 2 STOP)
		xor	a		; CLEAR CARRY FOR START BIT

CO1:		jp	nc, CC1		; IF CARRY, WILL SET LINE HIGH
		in	a, (PIO_PB1)	; READ SERIAL LINE
		and	0DFh
		out	(PIO_PB1), a	; SET SERIAL LINE LOW
		jp	CC2
CC1:		in	a, (PIO_PB1)	; READ SERIAL LINE
		or	20h
		out	(PIO_PB1), a	; SET SERIAL LINE HIGH
		nop
CC2:		ld	hl, (BITTIM)	; TIME PER BIT
CO2:		dec	l
		jp	nz, CO2		; IDLE FOR ONE BIT TIME
		dec	h
		jp	nz, CO2		; IDLE FOR ONE BIT TIME
		scf			; SET CARRY HIGH FOR NEXT BIT
		ld	a, c		; A=CHARACTER
		rra			; SHIFT IT INTO THE CARRY
		ld	c, a
		nop			; SOME TIMING CORRECTION FOR 19200 BAUD
		nop
		nop
		dec	b		; --BIT COUNT
		jp	nz, CO1		; SEND ENTIRE CHARACTER
		pop	bc
		pop	hl
		pop	af
		ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; CIN -	INPUT A	CHARACTER TO A.
;
; HALFBT IS THE	TIME FOR A HALF BIT TRANSITION ON THE SERIAL INPUT
; LINEIT IS CALCULATED AS FOLLOWS: (BITTIM-101H)/2*101H
BCIN:		di
		push	hl
		push	bc
		ld	b, 9		; BIT COUNT (START * 8 DATA)
		ld	hl, (HALFTIM)	; GET 1/2 BIT TIME

CI1:		in	a, (PIO_PB1)	; READ SERIAL LINE
		rla			; ISOLATE SERIAL BIT
		jr	nc, CI1		; WAIT TILL START BIT COMES(FAST VERSION)

CI2:		dec	l
		jp	nz, CI2		; WAIT TILL MIDDLE OF START BIT
		dec	h
		jp	nz, CI2

CI3:		ld	hl, (BITTIM)	; BIT TIME
		nop			; DELAY SO TIMING MATCHES THAT IN OUTPUT
		nop			; ROUTINE
		nop
CI4:		dec	l
		jp	nz, CI4		; NOW WAIT ONE ENTIRE BIT TIME
		dec	h
		jp	nz, CI4
		in	a, (PIO_PB1)	; READ SERIAL CHARACTER
		and	80h		; ISOLATE SERIAL DATA
		jp	nz, CI6		; J IF DATA IS <> 0
		inc	a		; SET BIT 0 TO 1
CI6:		rra			; ROTATE BIT 0 IT INTO CARRV
		dec	b		; DEC BIT COUNT
		jp	z, CI5		; J IF LAST BIT

		ld	a, c		; THIS IS WHERE WE ASSEMBLE CHAR
		rra			; ROTATE IT INTO THE CHARACTER FROM CARRY
		ld	c, a
		jp	CI3		; DO NEXT BIT

CI5:		ld	a, c
		ld	(CHAR_IN), a
		pop	bc
		pop	hl
		ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		end
